#include <target/herrno.h>
#include <target/htypes.h>
#include <target/str.h>
#include "memregions.h"
#include "board.h"
#include <target/param.h>

static int 
setclock_cmdfunc(int argc, char *argv[])
{
	int ret;

	/* initialize parameter: clock, using default clk */
	if (!check_param("@clock")) {
		char *c_argv[2] = {argv[0], "400"};
		if (default_clk() == CLK_532MHZ)
			c_argv[1] = "532";
		sethermit_param(2, c_argv, "@clock");
	}

	if (argc > 1)
		if (strcmp(argv[1], "532") != 0 &&
		    strcmp(argv[1], "400") != 0)
			return -H_EINVAL;

	ret = sethermit_param(argc, argv, "@clock");
	if (ret < 0)
		return ret;

	if (argc > 1) {
		if (strcmp(argv[1], "532") == 0)
			ret = change_clk(CLK_532MHZ, 0);
		else
			ret = change_clk(CLK_399MHZ, 0);
	}

	return ret;
}

const command_t setclock_command =
	{"setclock", "<400/532>", "set mcu_clk", &setclock_cmdfunc};

COMMAND(setclock_command);
